package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.scheduling.management.SchTerminator;
import com.docus.server.infrastructure.dao.ISchTerminatorDao;
import com.docus.server.infrastructure.mapper.SchTerminatorMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 执行管理器 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-07-15
 */
@Repository
public class SchTerminatorDaoImpl extends BaseDaoImpl<SchTerminatorMapper, SchTerminator> implements ISchTerminatorDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchTerminator findById(String id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param schTerminator 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(SchTerminator schTerminator) {
        return super.save(schTerminator);
    }

    /**
     * 编辑
     *
     * @param schTerminator 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(SchTerminator schTerminator) {
        return super.updateById(schTerminator);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchTerminator> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<SchTerminator> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(SchTerminator::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(SchTerminator::getCreateTime, endTime);
        }

        //在线状态
        if (searchDTO.getParams("onlineState") != null) {
            query.eq(SchTerminator::getOnlineState, searchDTO.getParams("onlineState"));
        }

        //默认createTime倒序排序
        query.orderByDesc(SchTerminator::getCreateTime);
        List<SchTerminator> list = super.find(query);
        return new PageResult<>(list);
    }

}
